<script type='text/javascript' src='https://service.force.com/embeddedservice/5.0/esw.min.js'></script>
<script type='text/javascript'> 

    // Inicialización de los reintentos que se usan para asegurarse que los componentes han sido cargados
    var attempts_iframe = 0;
    var attempts_availability = 0;

    // gslbBaseURL es un parámetro establecido por Salesforce. No debe cambiarse
    // errorMessage contiene el código de error que ha provocado que se muestre el chat. Se trata de unos campos a medida que se esperan al crear el chat
    // language se usa para saber si el chat debe enrutarse al grupo que gestiona Catalán o al de Castellano, y para completar información del caso. Dependerá de si el chat se aloja en una página de catalán o no. Sólo acepta los valores admitios en Case.SCA_LanguageWeb__c que son 'Catalan' y 'Castellano'
    // langCode se usa para indicar el idioma que debe usarse para cargar las etiquetas definidas en Salesforce. Generalmente se usará 'es' o 'ca'
    // urlOrigin es un string con la página que embebe el chat. Por ejemplo 'https://www.segurcaixaadeslas.es/_login/sca-login.aspx'
    // userData es un objeto en estructura JSON con los campos necesarios para identificar al usuario. Si se rellena, el chat se inicializará con estos valores
    // La estructura de este JSON es {firstName, lastName, documentNumber, birthDate}
    var initESW = function (gslbBaseURL, errorMessage, language, langCode,urlOrigin,userData) {

        // Si langCode o language no tienen valores esperados, se inicializan a valores por defecto
        langCode = (langCode !== 'es' && langCode !== 'ca') ? 'es' : langCode;
        language = (language !== 'Castellano' && language !== 'Catalan') ? 'Castellano' : language;

        embedded_svc.settings.displayHelpButton = false;
        embedded_svc.settings.language = langCode; //For example, enter 'es', 'en' or 'en-US'. Don't use 'es-ES'

        embedded_svc.settings.defaultMinimizedText = (language ==='Catalan') ? 'Xateja amb un gestor' : 'Chatea con un Gestor';
        embedded_svc.settings.disabledMinimizedText = (language ==='Catalan') ? 'Et cridarem' : 'Te llamamos'; 

        embedded_svc.settings.loadingText = (language ==='Catalan') ? 'Carregant...' : 'Cargando...';

        embedded_svc.settings.prepopulatedPrechatFields = { 
            SCA_ErrorMessage__c: errorMessage, 
            SCA_LanguageWeb__c: language, 
            SCA_URLOrigin__c: urlOrigin, 
            FirstName: userData === null ? '' : userData.firstName,
            LastName: userData === null ? '' : userData.lastName,
            SCA_IdentificationDocument__c: userData === null ? '' : userData.documentNumber,
            SCA_BirthdateText__c: userData === null ? '' : userData.birthDate
        }; //Sets the auto-population of pre-chat form fields
        
        embedded_svc.settings.offlineSupportMinimizedText = (language ==='Catalan') ? 'Et cridarem' : 'Te llamamos'; 
        embedded_svc.settings.enabledFeatures = ['LiveAgent'];
        embedded_svc.settings.entryFeature = 'LiveAgent';

        if (language === 'Catalan') {
            // -- ACTUALIZAR -- Todos los literales de esta sección tienen que actualizarse SI EN SALESFORCE SE CREO UN PRECHAT NUEVO
            embedded_svc.settings.extraPrechatInfo = [
                {
                    'entityFieldMaps': [
                        {
                            'doCreate': true,
                            'doFind': false,
                            'fieldName': 'LastName',
                            'isExactMatch': true,
                            'label': 'Cognoms'
                        },
                        {
                            'doCreate': true,
                            'doFind': false,
                            'fieldName': 'FirstName',
                            'isExactMatch': true,
                            'label': 'Nom'
                        },
                        {
                            'doCreate': true,
                            'doFind': true,
                            'fieldName': 'SCA_ContactNumberDocument__c',
                            'isExactMatch': true,
                            'label': 'Nº de document (DNI,NIE,Passaport)'
                        },
                        {
                            'doCreate': true,
                            'doFind': true,
                            'fieldName': 'SCA_BirthDateChat__c',
                            'isExactMatch': true,
                            'label': 'Data de naixement'
                        }
                    ],
                    'entityName': 'Contact',
                    'saveToTranscript': 'ContactId'
                }
            ];

            // En este punto es donde se carga el chat realmente. Hasta entonces eran acciones relacionadas con el prechat
            // -- ACTUALIZAR -- Todos los literales de esta sección tienen que actualizarse SI EN SALESFORCE SE CREO UN CHAT NUEVO
            embedded_svc.init(
                'https://scacorp.my.salesforce.com',
                'https://scacorp.my.salesforce-sites.com/ChatSegurCaixaAdeslas',
                gslbBaseURL,
                '00D2p000000QWx0',
                'SCA_SVC_Chat_Catalan',
                {
                    baseLiveAgentContentURL: 'https://c.la1-c2-cdg.salesforceliveagent.com/content',
                    deploymentId: '5722p0000000G38',
                    buttonId: '5732p0000000Gl4',
                    baseLiveAgentURL: 'https://d.la1-c2-cdg.salesforceliveagent.com/chat',
                    eswLiveAgentDevName: 'EmbeddedServiceLiveAgent_Parent04I2p000000kBNDEA2_170870bb646',
                    isOfflineSupportEnabled: false
                }
            );
        }
        else {
            // -- ACTUALIZAR -- Todos los literales de esta sección tienen que actualizarse SI EN SALESFORCE SE CREO UN PRECHAT NUEVO
            embedded_svc.settings.extraPrechatInfo = [
                {
                    'entityFieldMaps': [
                        {
                            'doCreate': true,
                            'doFind': false,
                            'fieldName': 'LastName',
                            'isExactMatch': true,
                            'label': 'Apellidos'
                        },
                        {
                            'doCreate': true,
                            'doFind': false,
                            'fieldName': 'FirstName',
                            'isExactMatch': true,
                            'label': 'Nombre'
                        },
                        {
                            'doCreate': true,
                            'doFind': true,
                            'fieldName': 'SCA_ContactNumberDocument__c',
                            'isExactMatch': true,
                            'label': 'Nº de documento (DNI,NIE,Pasaporte)'
                        },
                        {
                            'doCreate': true,
                            'doFind': true,
                            'fieldName': 'SCA_BirthDateChat__c',
                            'isExactMatch': true,
                            'label': 'Fecha de nacimiento'
                        }
                    ],
                    'entityName': 'Contact',
                    'saveToTranscript': 'ContactId'
                }

            ];
            // En este punto es donde se carga el chat realmente. Hasta entonces eran acciones relacionadas con el prechat
            // -- ACTUALIZAR -- Todos los literales de esta sección tienen que actualizarse SI EN SALESFORCE SE CREO UN CHAT NUEVO
            embedded_svc.init(
                'https://scacorp.my.salesforce.com',
                'https://scacorp.my.salesforce-sites.com/ChatSegurCaixaAdeslas',
                gslbBaseURL,
                '00D2p000000QWx0',
                'SCA_SVC_Chat',
                {
                    baseLiveAgentContentURL: 'https://c.la1-c2-cdg.salesforceliveagent.com/content',
                    deploymentId: '5722p0000000G33',
                    buttonId: '5732p0000000Gkz',
                    baseLiveAgentURL: 'https://d.la1-c2-cdg.salesforceliveagent.com/chat',
                    eswLiveAgentDevName: 'EmbeddedServiceLiveAgent_Parent04I2p000000kBN8EAM_17087079b01',
                    isOfflineSupportEnabled: false
                }
            );

        }
    };

    // Esta función oculta la sección donde se muestra el chat
    function hideChat(){
        document.getElementsByClassName('embeddedServiceHelpButton')[0].style.display = 'none';
    }

    // Esta función muestra la sección donde se muestra el chat
    function showChat(){
        document.getElementsByClassName('embeddedServiceHelpButton')[0].style.display = 'block';
    }
    
    // La primera vez que se carga el chat, simplemente se muestra un botón en la parte inferior. 
    // Cuando se pulsa ese botón se llama a esta función para decidir la acción más adecuada 
    // Si pone 'Te llamamos' es que no hay agentes conectado. De lo contrario sí los hay, y comenzaría el flujo propiamente dicho del chat (carga de prechat, espera en cola, chatear con agente...)
    function loadChatButton() {   
        if (document.getElementsByClassName('helpButtonLabel').length != 0) {
            if (document.getElementsByClassName('helpButtonLabel')[0].innerText.includes('Te llamamos')
                || document.getElementsByClassName('helpButtonLabel')[0].innerText.includes('Et cridarem') ) {
                    // Para saber si hay agentes conectados hay que consultar el texto del label del botón, el cual es actualizado automáticamente por la librería de Salesforce
                    // ACTUALIZAR - Completar con la operativa offline que se haya definido (si es que hay alguna). Por ejemplo hideChat() o redirigir / mostrar un formulario
                }
            else {
                // Si hay agentes conectados, se carga el chat propiamente dicho, empezando por el prechat.
                window.embedded_svc.onHelpButtonClick();
                // Si en vez de que se muestre el chat a pantalla completa, se quiere que el chat empiece minimizado y sea el usuario quien lo maximice haciendo click en él, se debería llamar a showChat()
                // showChat();
            }
        } else {
            // Nunca debería pasar por aquí, ya que si ha pulsado sobre el helpButton, es porque existe
            // No obstante, se podría poner alguna acción por si acaso
        }		
    }


    // Se ha visto que en ocasiones se buscaban elementos DOM del chat cuando aún no se había cargado el iframe del chat, y esto provacaba que se mostrase el formulario offline.
    // Si después de 10 segundos el iframe del chat de salesforce no se ha cargado, se mostrará el formulario offline.
    // Una vez cargado el iFrame del chat de Salesforce, es necesario esperar un poco para asegurar que no hay agentes conectados y mostrar el formulario.
    function waitForSFIframeReady() {
        if (embedded_svc.isIframeReady){	
            waitForSFChatAvailability();
        } else {
            if (attempts_iframe < 10) {
                attempts_iframe = attempts_iframe + 1;
                setTimeout(waitForSFIframeReady, 1000);
            }
            else
                console.log('Chat Iframe not ready');
                // ACTUALIZAR - Incluir lo que se deba realizar cuando no se ha podido cargar el chat. Por ejemplo hideChat() o redirigir / mostrar un formulario
        }
    }

    // Si no hay agentes conectados, se muestra el mensaj de 'Te llamamos' que redirije al formulario. Para estar seguros de que no se produce un cambio de estado, se verifica durante 3 segundos seguidos
    // En ocasiones se había visto que nada más cargar el iframe del chat, se mostraba 'Te llamamos' (sin agentes conectados) pero cambiaba poco después (en realidad sí había agentes conectados)
    function waitForSFChatAvailability(){
        if (document.getElementsByClassName('helpButtonLabel').length != 0 
            && !document.getElementsByClassName('helpButtonLabel')[0].innerText.includes('Te llamamos') 
            && !document.getElementsByClassName('helpButtonLabel')[0].innerText.includes('Et cridarem' )) { 
                loadChatButton();
                
        } else {
            if (attempts_availability < 6) {
                attempts_availability = attempts_availability + 1;
                setTimeout(waitForSFChatAvailability, 500);
            }
            else{
                // ACTUALIZAR - Incluir lo que se deba realizar cuando no hay agentes conectados. Por ejemplo hideChat() o redirigir / mostrar un formulario
            }
        }		
    }

    // Función a la que se debe llamar desde el HTML que embebe el componete para cargar el iFrame del chat y las librerías de Salesforce.
    // Se supone que se llamará cuando la página HTML haya recibido un error y pueda por tanto rellenar el atributo errorMessage
    // Sucesivas llamadas a esta función no alterarán el funcionamiento del chat (lenguaje de las etiquetas y otros parámetros). Una vez inicializado initESW los valores no cambiarán si se vuelve a llamar
    function loadComponent(language, langCode,errorMessage,urlOrigin,userData) {  
        if (!window.embedded_svc) {
            var s = document.createElement('script');
            s.setAttribute('src', 'https://scacorp--uat.my.salesforce.com/embeddedservice/5.0/esw.min.js');
            s.onload = function (errorMessage) {
                console.log(window.embedded_svc);
                console.log(window.embedded_svc.settings);
                initESW(null, errorMessage, language, langCode,urlOrigin,userData);
            };    
            document.body.appendChild(s);
        } else {
            initESW('https://service.force.com', errorMessage, language, langCode,urlOrigin,userData);
        }
        
        // Comienzan los mecanismos de reintentos para asegurarse que no hay problemas por delays durante la carga de componentes o por latencia de red
        attempts_iframe = 0;
        attempts_availability = 0;
        waitForSFIframeReady();
    }
</script>